rm(list=ls())

#changer le rpertoire courant
setwd("D:/DataMining/Databases_for_mining/dataset_for_soft_dev_and_comparison/regression/RExcel")

#charger les donnes -> chantillon d'apprentissage
library(xlsx)
ventes_train <- read.xlsx(file="ventes_regression_rexcel.xlsx",sheetName="VENTES.TRAIN")
print(summary(ventes_train))


#rgression complte sur l'chantillon d'apprentissage
modele.full <- lm(VENTES ~., data = ventes_train)
print(summary(modele.full))

#modle avec slection de variables
library(MASS)
modele.selection <- stepAIC(modele.full,direction="backward")
print(summary(modele.selection))

#charger les donnes -> chantillon test
ventes_test <- read.xlsx(file="ventes_regression_rexcel.xlsx",sheetName="VENTES.TEST")

#prdiction du modle par dfaut
pred.def <- mean(ventes_train$VENTES)
ssr.ref <- sum((ventes_test$VENTES - pred.def)^2)
print(ssr.ref)

#prdiction du modle complet
pred.full <- predict(modele.full,newdata=ventes_test)
ssr.full <- sum((ventes_test$VENTES - pred.full)^2)
print(ssr.full)
rsq.full <- 1.0 - ssr.full/ssr.ref
print(rsq.full)

#prdiction du modle avec slection de variables
pred.sel <- predict(modele.selection,newdata=ventes_test)
ssr.selection <- sum((ventes_test$VENTES - pred.sel)^2)
print(ssr.selection)
rsq.selection <- 1.0 - ssr.selection/ssr.ref
print(rsq.selection)

#rcupration des coefficients
coefs <- modele.full$coefficients
print(names(coefs))

#exportation des donnes test avec les prdictions
ventes_new <- cbind(ventes_test,data.frame(pred.def,pred.full,pred.sel))
write.xlsx(ventes_new,file="ventes_output.xlsx",row.names=F)
